/* getprio.c - getprio */

#include <Globals.h>

/*------------------------------------------------------------------------
 * getprio -- return the scheduling priority of a given process
 *------------------------------------------------------------------------
 */
 
SYSCALL getprio( PROC_ID theProcess )
{    
#define theProc ((Process *)theProcess)

	if (isbadpid(theProc) || theProc->pstate == PRFREE)
		return(SYSERR);
	
	return(theProc->pprio);
	
#undef theProc
}
