//
// Long Multiply, Divide and Modulus routines.
//
// Shamelessly stolen from Metrowerks Mac 68K Libraries
//
// Bryan Turner
//


asm	__lmul__()
{
	movem.l	d2-d3,-(a7)
	move.l	d0,d2
	swap	d2
	mulu.w	d1,d2
	move.l	d1,d3
	swap	d3
	mulu.w	d0,d3
	add.w	d3,d2
	swap	d2
	clr.w	d2
	mulu.w	d1,d0
	add.l	d2,d0
	movem.l	(a7)+,d2-d3
	rts
}

asm __ldiv__()
{
	movem.l	d2-d3,-(a7)
	
	move.l	d1,d2
	clr.w	d2
	swap	d2
	bne		div_Other
	
	move.w	d0,d3
	clr.w	d0
	swap	d0
	beq		div_next
	
	divu.w	d1,d0
	move.w	d0,d2
	swap	d2

div_next:
	move.w	d3,d0
	clr.w	d0
	swap	d0

	movem.l	(a7)+,d2-d3
	rts

div_Other:
	move.w	d0,d2
	clr.w	d0
	swap	d0
	swap	d2
	move.l	d1,d3
	moveq	#0xF,d1
	
div_other_lup:
	add.l	d2,d2
	addx.l	d0,d0
	cmp.l	d3,d0
	bcs		div_other_next
	
	sub.l	d3,d0
div_other_next:
	dbra	d1,div_other_lup
	
	movem.l	(a7)+,d2-d3
	rts
}

asm	__lmod__()
{
	tst.l	d1
	bge		mod_next
	
	neg.l	d1
mod_next:
	tst.l	d0
	blt		mod_next2
	
	jmp		__ldiv__
mod_next2:
	neg.l	d0
	jsr		__ldiv__
	neg.l	d0
	rts
}