/* scount.c - scount */


#include <Globals.h>

/*------------------------------------------------------------------------
 *  scount  --  return a semaphore count
 *------------------------------------------------------------------------
 */


SYSCALL scount( SEM_ID theSemaphore)
{
#define theSem ((QItem *)theSemaphore)

	if (isbadsem(theSem) || theSem->key == SFREE)
		return(SYSERR);
	
	return theSem->key;

#undef theSem
}