/* wakeup.c - wakeup */

#include <Globals.h>

/*------------------------------------------------------------------------
 * wakeup  --  called by clock interrupt dispatcher to awaken processes
 *------------------------------------------------------------------------
 */

INTPROC	wakeup()
{
	while ( nonempty(xinuGlobs.sleepQ) &&
			firstkey(xinuGlobs.sleepQ) <= 0)
		ready( (PROC_ID)GetFirst(xinuGlobs.sleepQ), RESCHNO );
	
	if ( (areProcsAsleep = nonempty(xinuGlobs.sleepQ)) != 0 )	// BT: Edited to remove 'unwanted assignment' warning
		sltop = (short *) &(((QItem *)((long)xinuGlobs.sleepQ + ((QItem *)xinuGlobs.sleepQ)->next))->key);
	
	//resched(); --- BT: resched called in clkint after wakeup is called
	return 0;
}
