//
// TIOS Glue code for TI-OS and Kernel routines in Fargo II (v0.2.5)
// Stolen from work by David Ellsworth
//
// Bryan Turner
//

#include "TIOS.h"

//
// BT: Some functions removed, I believe them to be non-reentrant, and
//     would crash the calc if a Xinu process called them.
//
asm JumpTable()
{

	entry TI_ST_busy
	jmp 0x004FAD28
	
	entry TI_ST_redraw
	jmp 0x004FAD64
	
	entry TI_ST_message
	jmp 0x004FAE3A
	
	entry TI_HeapFreeIndir
	jmp 0x0046CA7C
	
	entry TI_HeapFree
	jmp 0x0046CA96
	
	entry TI_HeapAlloc
	jmp 0x0046CB14
	
	entry TI_HeapRealloc
	jmp 0x0046CC68
	
	entry TI_DrawStrXY
	jmp 0x004632F4
	
	entry TI_DrawCharXY
	jmp 0x00463C3C
	
	entry TI_FontSetSys
	jmp 0x00461D80
	
	entry TI_sprintf
	jmp 0x0049F1C6
	
	entry TI_vcbprintf
	jmp	0x0049E758

	entry TI_strcmp
	jmp 0x004FB7A4
	
	entry TI_strlen
	jmp 0x004FB6B4
	
	entry TI_strncmp
	jmp 0x004FB6CC
	
	entry TI_strncpy
	jmp 0x004FB720
	
	entry TI_strcat
	jmp 0x004FB754
	
	entry TI_strchr
	jmp 0x004FB778
	
	entry TI_FindSymEntry
	jmp 0x0046EF0A
	
}

