// set_evec.s - set_evec()

//------------------------------------------------------------------------
// set_evec -- set exception vector to point to an exception handler
//	set_evec(offset, func)
//		int offset;		/* vector number to assign */
//		int (*func)();		/* pointer to handler      */
//------------------------------------------------------------------------

asm long set_evec( long offset, void (*func)() )
{
	movea.l	4(sp),a0	// load vbr[offset]
	move.l	(a0),d0		// return current value.
	move.l	8(sp),(a0)	// vbr[offset] = func
	move.b  7(sp),(a0)	// Store vector offset in high byte - 68K trick: used to tell which vector we took!
	rts
}