/* clkinit.c - clkinit */

#include <Globals.h>

extern int clkint();

/* real-time clock variables and sleeping process queue pointers	*/

// Bryan: Edited how RTCLOCK flag defines clkruns,
//        it was not even allowing it's definition before!
/*
 *------------------------------------------------------------------------
 * clkinit - initialize the clock and sleep queue (called at startup)
 *------------------------------------------------------------------------
 */
 
#undef areProcsAsleep
#undef sltop

//
// BT: TI-OS Compatable!  Yay!
//
void clkinit()
{
	// BT: Setup clock interrupt
	AsmClockInit();
	
	xinuGlobs.preempt = QUANTUM;
	xinuGlobs.areProcsAsleep = FALSE;	/* initially, no process asleep	*/
	xinuGlobs.sleepQ = NewQueue();
	
	//
	// Also install the KeyBoard interrupt..
	//
	AsmKeyInit();
}

