/* conoutput.c - conputc conwrite */

#include <conf.h>
#include <kernel.h>
#include <io.h>
#include <tty.h>    

extern void prputchar( unsigned char ch );	// BT: TI-OS version of prputchar()  :)

//
// --- Bryan: using the TI-ROM write routines... testing..
//
/*------------------------------------------------------------------------
 *  conputc - write one character to the display
 *------------------------------------------------------------------------
 */
// BT: fixed this up a bit..
void conputc( c, devptr )	// BT: reversed
	struct	devsw	*devptr;
     	register unsigned char c;
{
	if ( c == 0 )
		return;

	if (c==NEWLINE)
	    prputchar(RETURN);
	else
		prputchar(c);
}


/*------------------------------------------------------------------------
 *  conwrite - write to the display
 *------------------------------------------------------------------------
 */
conwrite(devptr, buff, count)
	struct	devsw	*devptr;
	char *buff;
	int count;
{

    if (count < 0)
		return(SYSERR);
    if (count == 0)
		return(OK);

    for (; count>0 ; count--)
		conputc(devptr, *buff++);

    return(OK);
}




