/* ready.c - ready */


#include <Globals.h>

/*------------------------------------------------------------------------
 * ready  --  make a process eligible for CPU service
 *------------------------------------------------------------------------
 */

int	ready ( PROC_ID theProcess, short resch)
{
#define theProc ((Process *)theProcess)

	if (isbadpid(theProc))
		return(SYSERR);
	
	theProc->pstate = PRREADY;
	InsertByKey( theProcess, xinuGlobs.readyQ, theProc->pprio);
	
	if (resch)
		resched();
	
	return(OK);
}
