/* sendf.c - sendf */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  sendf  --  sendf a message to another process, forcing delivery
 *------------------------------------------------------------------------
 */
SYSCALL	sendf( PROC_ID theProcess, WORD msg)
{
	short sr; 
	long a4;    
#define theProc ((Process *)theProcess)

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	if (isbadpid(theProc)||(theProc->pstate == PRFREE))
		{
		RestoreA4AndSR(a4,sr);
		return(SYSERR);
		}
	theProc->pmsg = msg;
	theProc->phasmsg++;
	if (theProc->pstate == PRRECV)
		ready( theProcess, RESCHYES);
	
	RestoreA4AndSR(a4,sr);
	return(OK);
}
