/* setnok.c - setnok */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  setnok  -  set next-of-kin (notified at death) for a given process
 *------------------------------------------------------------------------
 */

SYSCALL	setnok( PROC_ID nok, PROC_ID theProcess)
{
	short sr;    
#define theProc ((Process *)theProcess)

	
	if (isbadpid(theProc))
		return(SYSERR);
	
	sr = disable();
	
	theProc->pnxtkin = nok;
	
	restore(sr);
	return(OK);
}
